package kr.go.busan.bsopenapp;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import kr.go.busan.service.GcmIntentService;
import kr.go.busan.bsopenapp.R;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.android.gms.gcm.GoogleCloudMessaging;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.ActivityManager;
import android.app.AlertDialog;
import android.app.NotificationManager;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager.NameNotFoundException;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.webkit.WebBackForwardList;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Toast;

public class MainActivity extends Activity {
	public static MainActivity main = null;
	public WebView web = null;
	public SharedPreferences mPreferences;
	private static final String TAG = "MainActivity";

	private Boolean bFinish = false;
	
	private Boolean bSaveInfo = false;

	@SuppressWarnings("deprecation")
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

//		startActivity(new Intent(this, SplashActivity.class));
		setContentView(R.layout.activity_main);

		mPreferences = getSharedPreferences("CurrentUser", MODE_PRIVATE); // public으로
																			// 하면
																			// 외부
																			// 접근
																			// 가능

		main = this;

		// 객체 생성 및 초기화, 사이즈 변경
		init();

		// 웹 로드
		webLoad();

		// ///////////////////
		// Register GCM Service
		// Check device for Play Services APK. If check succeeds, proceed with
		// GCM registration.
		if (checkPlayServices()) {
			gcm = GoogleCloudMessaging.getInstance(this);
			regid = getRegistrationId(main);

			registerInBackground();
			if (regid.isEmpty()) {
				registerInBackground();
			} else {
				Log.i(TAG, "No valid Google Play Services APK found.");
			}
		}

		try {
			String braodcastMsg = getIntent().getStringExtra("BroadCast");
			if (braodcastMsg.length() > 0) {
				braodcastMsg = "0";
				NotificationManager nm = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
				// 등록된 notification 을 제거 한다.
				nm.cancel(GcmIntentService.NOTIFICATION_ID);
			}
		} catch (Exception e) {

		}
		// ///////////////////

	}

	private void init() {
		// 웹뷰
		web = (WebView) findViewById(R.id.WebView);
	}

	@SuppressLint("SetJavaScriptEnabled")
	private void webLoad() {
		String url = this.getIntent().getDataString();
		if (url == null || url.trim().equals("")) {
			url = Info.getURL(0);
		}

		String userID = mPreferences.getString("userID", "");
		// Toast.makeText(main, userID, Toast.LENGTH_LONG).show();
		if (userID != null && !userID.trim().equals("")) {
			url += ("?id=" + userID);
		}

		web.getSettings().setJavaScriptEnabled(true);
		web.getSettings().setAllowFileAccess(true);
		web.getSettings().setAllowUniversalAccessFromFileURLs(true);
		web.getSettings().setAllowContentAccess(true);
		web.getSettings().setAllowFileAccessFromFileURLs(true);
		web.getSettings().setSupportZoom(true);
		web.getSettings().setBuiltInZoomControls(true);
		web.clearCache(true);
		web.clearHistory();
		web.clearFormData();
		web.setWebViewClient(new MyWebViewClient());

		web.setWebChromeClient(new MyWebChromeClient());

		web.loadUrl(url);
		
		Map<String, String> extraHeaders = new HashMap<String, String>();
		  extraHeaders.put("ACCEPT", "text/html");
		  web.loadUrl(url, extraHeaders);
		//web.loadUrl()
	}

	final class MyWebChromeClient extends WebChromeClient {
		public boolean onJsAlert(WebView view, String url, String message,
				final android.webkit.JsResult result) {
			// result.confirm();
			// return true;

			// 웹뷰에 얼럿창 띄움
			new AlertDialog.Builder(MainActivity.this)
					.setTitle("알림")
					.setMessage(message)
					.setPositiveButton(android.R.string.ok,
							new AlertDialog.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int which) {
									result.confirm();
								}
							}).setCancelable(false).create().show();

			Log.i("Message", message);
			return true;
		}
	}

	private class MyWebViewClient extends WebViewClient {
		String[] m_xmlString; // app url 모음

		// XML 파일에서 URL을 추출한다.
		public void parseXML(String xml) {
			try {
				DocumentBuilderFactory factory = DocumentBuilderFactory
						.newInstance();
				DocumentBuilder documentBuilder = factory.newDocumentBuilder();

				InputStream is = new ByteArrayInputStream(xml.getBytes());
				Document doc = documentBuilder.parse(is);
				org.w3c.dom.Element element = doc.getDocumentElement();
				NodeList items = element.getElementsByTagName("url");
				int n = items.getLength();

				m_xmlString = new String[n];

				for (int i = 0; i < n; i++) {
					Node item = items.item(i);
					Node text = item.getFirstChild();
					String itemValue = text.getNodeValue();

					m_xmlString[i] = itemValue;
				}

			} catch (Exception e) {
			}
		}

		@SuppressLint("DefaultLocale")
		@Override
		public boolean shouldOverrideUrlLoading(WebView view, String url) {
			// Log.i("URL", url);
			if (url.endsWith(".mp4")) {

			}
//			else if (url.matches("http://192.168.174.16:8082/smvcex/BusanXML")
//					|| url.matches("http://192.168.174.16:8082/smvcex/BusanXMLbang2")) {
//	            Intent intent = new Intent(Intent.ACTION_VIEW);
//	            intent.setData(Uri.parse(url));
//	            startActivity(intent);
//			}
			else if (url.matches("market://.*")) {
				Intent intent = new Intent(Intent.ACTION_VIEW);
				intent.setData(Uri.parse(url));
				startActivity(intent);

			} else if (url.matches("http://play.google.com/store/apps/.*")) {
				Intent intent = new Intent(Intent.ACTION_VIEW);
				intent.setData(Uri.parse(url));
				startActivity(intent);

			} else if (url.contains("tel:")) {
				Intent intent = new Intent(Intent.ACTION_VIEW);
				intent.setData(Uri.parse(url));
				startActivity(intent);
			} else if (url.contains(Info.getURL(2))) {
				if (!bSaveInfo && url.indexOf("sid=") != -1) {
					String strMem_id = url.substring(url.indexOf("sid=") + 4);

					SharedPreferences.Editor prefEditor = mPreferences.edit();
					prefEditor.putString("userID", strMem_id);
					prefEditor.commit();
					//Toast.makeText(main, "정보가 저장 되었습니다.", Toast.LENGTH_LONG).show();
					// sendRegistrationIdToBackend();
					registerInBackgroundWithLogin();
				}
				view.loadUrl(url);
			} else {
				view.loadUrl(url);
			}
			return true;
		}

		ProgressDialog progressDialog = new ProgressDialog(MainActivity.this);

		@Override
		public void onPageFinished(WebView view, String url) {
			super.onPageFinished(view, url);
			progressDialog.hide();
			if (!web.canGoBack())
				progressDialog.dismiss();
			Log.i("URL", "Finished : " + url);
		}

		@Override
		public void onPageStarted(WebView view, String url, Bitmap favicon) {
			super.onPageStarted(view, url, favicon);
			progressDialog.setMessage("Searching.");
			progressDialog.setIndeterminate(true);
			progressDialog.show();
		}
	}

	@SuppressLint("HandlerLeak")
	@Override
	public void onBackPressed() {
		WebBackForwardList list = web.copyBackForwardList();
		String url = web.getUrl();

		if (url.contains(Info.getURL(0)) || url.contains(Info.getURL(1))) {
			super.onBackPressed(); // 없으면 종료
		} else if (url.contains(Info.getURL(2)) || url.contains(Info.getURL(3))
				|| url.contains(Info.getURL(4))) {
			if (bFinish) {
				super.onBackPressed(); // 없으면 종료
			} else {
				Handler mHandler = new Handler() {
					@SuppressWarnings("deprecation")
					@Override
					public void handleMessage(Message msg) {
						if (bFinish) {
							bFinish = false;
						}
					}
				};
				mHandler.sendEmptyMessageDelayed(0, 3000);
				Toast.makeText(main, "\'이전\' 버튼을 한번 더 누르면 종료됩니다.",
						Toast.LENGTH_LONG).show();
				bFinish = true;
			}
		} else if (web.canGoBack()) {
			web.goBack();
		}
	}

	/**
	 * Check the device to make sure it has the Google Play Services APK. If it
	 * doesn't, display a dialog that allows users to download the APK from the
	 * Google Play Store or enable it in the device's system settings.
	 */

	public static final String EXTRA_MESSAGE = "message";
	public static final String PROPERTY_REG_ID = "registration_id";
	private static final String PROPERTY_APP_VERSION = "appVersion";
	private static final int PLAY_SERVICES_RESOLUTION_REQUEST = 9000;
	GoogleCloudMessaging gcm;
	AtomicInteger msgId = new AtomicInteger();
	String SENDER_ID = "516844465941";
	/**
	 * Tag used on log messages.
	 */
	// static final String TAG = "GCM Demo";
	String regid;

	private boolean checkPlayServices() {
		int resultCode = GooglePlayServicesUtil
				.isGooglePlayServicesAvailable(this);
		if (resultCode != ConnectionResult.SUCCESS) {
			if (GooglePlayServicesUtil.isUserRecoverableError(resultCode)) {
				GooglePlayServicesUtil.getErrorDialog(resultCode, this,
						PLAY_SERVICES_RESOLUTION_REQUEST).show();
			} else {
				Log.i(TAG, "This device is not supported.");
				finish();
			}
			return false;
		}
		return true;
	}

	/**
	 * Stores the registration ID and the app versionCode in the application's
	 * {@code SharedPreferences}.
	 * 
	 * @param context
	 *            application's context.
	 * @param regId
	 *            registration ID
	 */
	private void storeRegistrationId(Context context, String regId) {
		final SharedPreferences prefs = getGcmPreferences(context);
		int appVersion = getAppVersion(context);
		Log.i(TAG, "Saving regId on app version " + appVersion);
		SharedPreferences.Editor editor = prefs.edit();
		editor.putString(PROPERTY_REG_ID, regId);
		editor.putInt(PROPERTY_APP_VERSION, appVersion);
		editor.commit();
	}

	/**
	 * Gets the current registration ID for application on GCM service, if there
	 * is one.
	 * <p>
	 * If result is empty, the app needs to register.
	 * 
	 * @return registration ID, or empty string if there is no existing
	 *         registration ID.
	 */
	private String getRegistrationId(Context context) {
		final SharedPreferences prefs = getGcmPreferences(context);
		// SharedPreferences.Editor editor = prefs.edit();
		// editor.remove(PROPERTY_REG_ID);
		// editor.commit();
		String registrationId = prefs.getString(PROPERTY_REG_ID, "");
		if (registrationId.isEmpty()) {
			Log.i(TAG, "Registration not found.");
			return "";
		}
		// Check if app was updated; if so, it must clear the registration ID
		// since the existing regID is not guaranteed to work with the new
		// app version.
		int registeredVersion = prefs.getInt(PROPERTY_APP_VERSION,
				Integer.MIN_VALUE);
		int currentVersion = getAppVersion(context);
		if (registeredVersion != currentVersion) {
			Log.i(TAG, "App version changed.");
			return "";
		}
		return registrationId;
	}

	/**
	 * Registers the application with GCM servers asynchronously.
	 * <p>
	 * Stores the registration ID and the app versionCode in the application's
	 * shared preferences.
	 */
	private void registerInBackground() {
		new AsyncTask<Void, Void, String>() {
			@Override
			protected String doInBackground(Void... params) {
				String msg = "";
				try {
					if (gcm == null) {
						gcm = GoogleCloudMessaging.getInstance(main);
					}
					regid = gcm.register(SENDER_ID);
					msg = "Device registered, registration ID=" + regid;

					// You should send the registration ID to your server over
					// HTTP, so it
					// can use GCM/HTTP or CCS to send messages to your app.

					// 로그인시 등록
					// sendRegistrationIdToBackend();

					// For this demo: we don't need to send it because the
					// device will send
					// upstream messages to a server that echo back the message
					// using the
					// 'from' address in the message.

					// Persist the regID - no need to register again.
					storeRegistrationId(main, regid);
				} catch (IOException ex) {
					msg = "Error :" + ex.getMessage();
					// If there is an error, don't just keep trying to register.
					// Require the user to click a button again, or perform
					// exponential back-off.
				}
				return msg;
			}

			@Override
			protected void onPostExecute(String msg) {
				// mDisplay.append(msg + "\n");
			}
		}.execute(null, null, null);
	}

	// // Send an upstream message.
	// public void onClick(final View view) {
	//
	// if (view == findViewById(R.id.send)) {
	// new AsyncTask<Void, Void, String>() {
	// @Override
	// protected String doInBackground(Void... params) {
	// String msg = "";
	// try {
	// Bundle data = new Bundle();
	// data.putString("my_message", "Hello World");
	// data.putString("my_action", "com.google.android.gcm.demo.app.ECHO_NOW");
	// String id = Integer.toString(msgId.incrementAndGet());
	// gcm.send(SENDER_ID + "@gcm.googleapis.com", id, data);
	// msg = "Sent message";
	// } catch (IOException ex) {
	// msg = "Error :" + ex.getMessage();
	// }
	// return msg;
	// }
	//
	// @Override
	// protected void onPostExecute(String msg) {
	// mDisplay.append(msg + "\n");
	// }
	// }.execute(null, null, null);
	// } else if (view == findViewById(R.id.clear)) {
	// mDisplay.setText("");
	// }
	// }

	/**
	 * @return Application's version code from the {@code PackageManager}.
	 */
	private static int getAppVersion(Context context) {
		try {
			PackageInfo packageInfo = context.getPackageManager()
					.getPackageInfo(context.getPackageName(), 0);
			return packageInfo.versionCode;
		} catch (NameNotFoundException e) {
			// should never happen
			throw new RuntimeException("Could not get package name: " + e);
		}
	}

	/**
	 * @return Application's {@code SharedPreferences}.
	 */
	private SharedPreferences getGcmPreferences(Context context) {
		// This sample app persists the registration ID in shared preferences,
		// but
		// how you store the regID in your app is up to you.
		return getSharedPreferences(MainActivity.class.getSimpleName(),
				Context.MODE_PRIVATE);
	}

	/**
	 * Sends the registration ID to your server over HTTP, so it can use
	 * GCM/HTTP or CCS to send messages to your app. Not needed for this demo
	 * since the device sends upstream messages to a server that echoes back the
	 * message using the 'from' address in the message.
	 * 
	 * @throws IOException
	 */
	private void sendRegistrationIdToBackend() throws IOException {
		// Your implementation here
		// http://192.168.174.203:8080/sls/ws/insertPushService?type=A&protector_sid=test2&uniqid=APA91bHm2CnllN5j_VdIvRbIC4IOjXxmJ1OvPPgQH1Bd7mGO--Kpmj4IFs81W9C0XtyUxwM2Xw6yBgAd7Bv8DbEJeYQllFshieAJEup_uLwcM628OHcD8jc6es5yodZoTvWjjmJPVBziL9ekynMXBGXmpkpHpOky4Q
		String model = Build.MODEL;
		String userID = mPreferences.getString("userID", "");
		String strUrl = Info.getURL(5) + "?type=A&protector_sid=" + userID
				+ "&uniqid=" + regid;
		URL u = new URL(strUrl);
		HttpURLConnection huc = (HttpURLConnection) u.openConnection();

		huc.setRequestMethod("GET");
		huc.setDoInput(true);
		huc.setRequestProperty("Content-Type",
				"application/x-www-form-urlencoded");
		BufferedReader br = new BufferedReader(new InputStreamReader(
				huc.getInputStream(), "EUC-KR"), huc.getContentLength());
		String buf;
		while ((buf = br.readLine()) != null) {
			System.out.println(buf);
		}
		br.close();
		bSaveInfo = true;
	}

	/**
	 * Registers the application with GCM servers asynchronously.
	 * <p>
	 * Stores the registration ID and the app versionCode in the application's
	 * shared preferences.
	 */
	private void registerInBackgroundWithLogin() {
		new AsyncTask<Void, Void, String>() {
			@Override
			protected String doInBackground(Void... params) {
				String msg = "ok";
				try {

					sendRegistrationIdToBackend();

				} catch (IOException ex) {
					msg = "Error :" + ex.getMessage();
				}
				return msg;
			}

			@Override
			protected void onPostExecute(String msg) {
				// mDisplay.append(msg + "\n");
			}
		}.execute(null, null, null);
	}

}
